<script setup lang="ts">
import type FormFields from '@/types/formFields'
import { ErrorMessage, Field, Form } from 'vee-validate'
import { onMounted, ref, type Ref } from 'vue'
import ErrorDisplay from './ErrorDisplay.vue'

const props = defineProps<{
  title: string
  message?: string
  yesButtonLabel?: string
  noButtonLabel?: string
  schema: FormFields
  onDisplay?: () => Promise<void>
  onAction: (p: any) => Promise<void>
}>()

const modalDialog: Ref<HTMLDialogElement | null> = ref(null)
const loading = ref(false)
const loginError: Ref<Error | null> = ref(null)

onMounted(async () => {
  if (props.onDisplay) {
    loading.value = true
    loginError.value = null

    try {
      await props.onDisplay()
    } catch (error) {
      if (!(error instanceof Error)) {
        console.error(error)
      } else {
        loginError.value = error
      }
    }

    loading.value = false
  }
})

async function _onAction(values: any, handleReset: () => void) {
  loading.value = true
  loginError.value = null

  try {
    await props.onAction(values)

    _onClose(handleReset)
  } catch (error) {
    if (!(error instanceof Error)) {
      console.error(error)
    } else {
      loginError.value = error
    }
  }

  loading.value = false
}

function _onClose(handleReset: () => void) {
  loading.value = false
  loginError.value = null

  handleReset()

  if (modalDialog.value) {
    modalDialog.value.close()
  }
}
</script>

<!-- TODO reset les errors lors de la fermeture de la modale -->
<template>
  <div @click="modalDialog!!.showModal()">
    <slot></slot>
  </div>
  <dialog id="modalDialog" ref="modalDialog" class="modal modal-bottom sm:modal-middle">
    <div class="modal-box">
      <h3 class="font-bold text-lg whitespace-break-spaces">{{ title }}</h3>
      <p v-if="message" class="py-4 whitespace-break-spaces">{{ message }}</p>

      <Form v-slot="{ values, handleReset }">
        <div
          v-for="{ as, name, label, children, ...attrs } in props.schema.fields"
          :key="name"
          class="form-control"
        >
          <label :for="name" class="label">
            <span class="label-text">{{ label }}</span>
          </label>
          <!-- TODO Dans le cas des combos, utiliser les Listbox de HeadlessUI -->
          <Field :as="as" :id="name" :name="name" :class="`${as} ${as}-bordered`" v-bind="attrs">
            <template v-if="children && children.length">
              <component
                v-for="({ tag, text, ...childAttrs }, idx) in children"
                :key="idx"
                :is="tag"
                v-bind="childAttrs"
              >
                {{ text }}
              </component>
            </template>
          </Field>
          <ErrorMessage :name="name" class="label-text-alt" />
        </div>

        <ErrorDisplay :login-error="loginError" />

        <div class="modal-action">
          <div class="flex gap-2">
            <button
              class="btn btn-sm"
              type="button"
              :disabled="loading"
              @click="_onAction(values, handleReset)"
            >
              {{ yesButtonLabel ?? 'Oui' }}
            </button>
            <button
              class="btn btn-sm btn-primary"
              type="submit"
              @click="_onClose(handleReset)"
              :disabled="loading"
            >
              {{ noButtonLabel ?? 'Non' }}
            </button>
          </div>
        </div>
      </Form>
    </div>
  </dialog>
</template>
